﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using AirFighter.DrawningObjects;
using AirFighter.Drawnings;
using AirFighter.Generics;
using AirFighter.MovementStrategy;

namespace AirFighter
{
    public partial class FormFighterCollection : Form
    {
        private readonly AirFighterGenericCollection<DrawningAirFighter, DrawningObjectAirFighter> _fighter;
        public FormFighterCollection()
        {
            InitializeComponent();
            _fighter = new AirFighterGenericCollection<DrawningAirFighter, DrawningObjectAirFighter>(pictureBoxCollection.Width, pictureBoxCollection.Height);
        }

        private void ButtonAddAirFighter_Click(object sender, EventArgs e)
        {
            FormAirFighter form = new();
            if (form.ShowDialog() == DialogResult.OK)
            {
                if (_fighter + form.SelectedAirFighter != null)
                {
                    MessageBox.Show("Объект добавлен");
                    pictureBoxCollection.Image = _fighter.ShowAirFighter();
                }
                else
                {
                    MessageBox.Show("Не удалось добавить объект");
                }

            }

        }

        private void ButtonRemoveAirFighter_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Удалить объект?", "Удаление", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No)
            {
                return;
            }
            int pos = Convert.ToInt32(maskedTextBoxNumber.Text);
            if (_fighter - pos != null)
            {
                MessageBox.Show("Объект удален");
                pictureBoxCollection.Image = _fighter.ShowAirFighter();
            }
            else
            {
                MessageBox.Show("Не удалось удалить объект");
            }

        }

        private void ButtonRefreshCollection_Click(object sender, EventArgs e)
        {
            pictureBoxCollection.Image = _fighter.ShowAirFighter();
        }
    }
}
