﻿namespace AirFighter.Generics
{
    internal class SetGeneric<T>
    where T : class
    {
        private readonly T[] _places;
        public int Count => _places.Length;
        public SetGeneric(int count)
        {
            _places = new T[count];
        }
        public int Insert(T fighter)
        {
            for (int i = 0; i < _places.Length; i++)
            {
                if (_places[i] == null)
                {
                    _places[i] = fighter;
                    return i;
                }
            }
            return -1;

        }
        public int Insert(T fighter, int position)
        {
            int index = position;

            while (_places[index] != null && index < _places.Length) index++;

            if (index == _places.Length) return -1;
            for (int i = index; i > position; --i) _places[i] = _places[i - 1];

            _places[position] = fighter;
            return position;
        }
        public bool Remove(int position)
        {
            if (position < 0 || position >= _places.Length)
            {
                return false;
            }
            _places[position] = null;
            return true;
        }
        public T? Get(int position)
        {
            if (position < 0 || position >= _places.Length)
            {
                return null;
            }
            return _places[position];
        }
    }
}

